diff -r -c ../ingres.ptf/source/decomp/Makefile source/decomp/Makefile
*** ../ingres.ptf/source/decomp/Makefile	Mon Nov 16 14:38:23 1992
--- source/decomp/Makefile	Wed Sep 23 16:09:20 1992
***************
*** 33,39 ****
  	lockit.c pull_const.c \
  	call_ovqp.c call_dbu.c 
  
! CFLAGS=	-I$H -O
  LINTFLAGS= -huc -I$H
  LDFLAGS=
  AR=	-ar
--- 33,39 ----
  	lockit.c pull_const.c \
  	call_ovqp.c call_dbu.c 
  
! CFLAGS=	-O -I$H 
  LINTFLAGS= -huc -I$H
  LDFLAGS=
  AR=	-ar
diff -r -c ../ingres.ptf/source/decomp/de_init.c source/decomp/de_init.c
*** ../ingres.ptf/source/decomp/de_init.c	Mon Nov 16 14:38:22 1992
--- source/decomp/de_init.c	Mon Oct 19 18:51:07 1992
***************
*** 7,12 ****
--- 7,13 ----
  SCCSID(@(#)de_init.c	8.1	12/31/84)
  
  /*ARGSUSED*/
+ void
  de_init(argc, argv)
  int	argc;
  char	**argv;
***************
*** 42,48 ****
  **		rubcatch
  */
  
! 
  de_rubproc()
  {
  	extern int	Equel;
--- 43,49 ----
  **		rubcatch
  */
  
! void
  de_rubproc()
  {
  	extern int	Equel;
***************
*** 60,64 ****
  
  	endovqp(RUBACK);
  	reinit();
! 	return;
  }
--- 61,65 ----
  
  	endovqp(RUBACK);
  	reinit();
! /*	return;           by  K.Okamoto     */
  }
diff -r -c ../ingres.ptf/source/decomp/globs.h source/decomp/globs.h
*** ../ingres.ptf/source/decomp/globs.h	Mon Nov 16 14:38:21 1992
--- source/decomp/globs.h	Thu Jun  4 12:00:32 1992
***************
*** 80,86 ****
  {
  	int	relop;	/* value of relop in simp clause*/
  	int	att;	/* attno of attribute */
! 	SYMBOL	*const;	/* pointer to constant value symbol */
  };
  
  
--- 80,86 ----
  {
  	int	relop;	/* value of relop in simp clause*/
  	int	att;	/* attno of attribute */
!         SYMBOL  *constv; /* pointer to constant value symbol */
  };
  
  
diff -r -c ../ingres.ptf/source/decomp/openrs.c source/decomp/openrs.c
*** ../ingres.ptf/source/decomp/openrs.c	Mon Nov 16 14:38:23 1992
--- source/decomp/openrs.c	Tue Sep 15 11:40:55 1992
***************
*** 254,259 ****
--- 254,260 ----
  int	var;
  {
  	register struct desc_tab	*dt;
+ 	struct desc_tab			*desc_get();
  
  	/* get descv for the relation */
  	dt = desc_get(De.de_rangev[var].relnum, TRUE);
diff -r -c ../ingres.ptf/source/decomp/qryproc.c source/decomp/qryproc.c
*** ../ingres.ptf/source/decomp/qryproc.c	Mon Nov 16 14:38:21 1992
--- source/decomp/qryproc.c	Fri Sep 25 14:51:52 1992
***************
*** 13,20 ****
  
  /* Control Module configuration information structure */
  
! extern	int de_init();
! extern	int de_rubproc();
  extern	int qryproc();
  
  struct fn_def	DeOvqpFn =
--- 13,20 ----
  
  /* Control Module configuration information structure */
  
! extern	void de_init();
! extern	void de_rubproc();
  extern	int qryproc();
  
  struct fn_def	DeOvqpFn =
diff -r -c ../ingres.ptf/source/decomp/usubr.c source/decomp/usubr.c
*** ../ingres.ptf/source/decomp/usubr.c	Mon Nov 16 14:38:22 1992
--- source/decomp/usubr.c	Fri Sep 25 15:01:07 1992
***************
*** 16,26 ****
--- 16,35 ----
  **	utility routines to handle setting up params, etc for DBU calls
  */
  
+ static char *getformat();
+ int         domnam();
+ int         lnode();
+ int         dstr_rel();
+ int         dstr_mark();
+ int         mak_t_rel();
+ QTREE       **mksqlist();
+ long        rel_pages();
  
  
  /*
   *	generate domain names, formats
   */
+ int
  domnam(lnp, pre)
  QTREE	**lnp;
  char	*pre;
***************
*** 62,68 ****
  /*
  **	makes list of nodes (depth first)
  */
! 
  lnode(nod, lnodv, count)
  QTREE 	*nod, *lnodv[];
  int	count;
--- 71,77 ----
  /*
  **	makes list of nodes (depth first)
  */
! int
  lnode(nod, lnodv, count)
  QTREE 	*nod, *lnodv[];
  int	count;
***************
*** 83,89 ****
  /*
  **	Immediately destroys the relation if it is an _SYS
  */
! 
  dstr_rel(relnum)
  int	relnum;
  {
--- 92,98 ----
  /*
  **	Immediately destroys the relation if it is an _SYS
  */
! int
  dstr_rel(relnum)
  int	relnum;
  {
***************
*** 104,110 ****
  **	Trace Flags:
  **		65
  */
! 
  dstr_mark(relnum)
  int	relnum;
  {
--- 113,119 ----
  **	Trace Flags:
  **		65
  */
! int
  dstr_mark(relnum)
  int	relnum;
  {
***************
*** 134,140 ****
  **	If rnum is positive, use it as the relation number,
  **	Otherwise allocate a new one.
  */
! 
  mak_t_rel(tree, prefix, rnum)
  QTREE	*tree;
  char	*prefix;
--- 143,149 ----
  **	If rnum is positive, use it as the relation number,
  **	Otherwise allocate a new one.
  */
! int
  mak_t_rel(tree, prefix, rnum)
  QTREE	*tree;
  char	*prefix;
diff -r -c ../ingres.ptf/source/equel/constants.h source/equel/constants.h
*** ../ingres.ptf/source/equel/constants.h	Mon Nov 16 14:38:30 1992
--- source/equel/constants.h	Mon Sep 14 18:14:16 1992
***************
*** 27,33 ****
  
  /* debugging info conditional compilation flag */
  # define	xDEBUG			/* on for "-c" and "-v" flags */
! # define	YYDEBUG			/* must ALWAYS be on-used in yyparse()*/
  
  
  /* 
--- 27,33 ----
  
  /* debugging info conditional compilation flag */
  # define	xDEBUG			/* on for "-c" and "-v" flags */
! # define	YYDEBUG	1		/* must ALWAYS be on-used in yyparse()*/
  
  
  /* 
diff -r -c ../ingres.ptf/source/equel/prtout.c source/equel/prtout.c
*** ../ingres.ptf/source/equel/prtout.c	Mon Nov 16 14:38:30 1992
--- source/equel/prtout.c	Thu Sep 10 17:43:35 1992
***************
*** 353,364 ****
  		{
  			if (In_quote)
  			{
! 				puts("\");\nIIwrite(\"", Out_file);
  				Charcnt = 9;
  			}
  			else
  			{
! 				puts("\\\n", Out_file);
  				Charcnt = 0;
  			}
  		}
--- 353,364 ----
  		{
  			if (In_quote)
  			{
! 				fputs("\");\nIIwrite(\"", Out_file);
  				Charcnt = 9;
  			}
  			else
  			{
! 				fputs("\\\n", Out_file);
  				Charcnt = 0;
  			}
  		}
***************
*** 374,379 ****
--- 374,381 ----
  **  PUTS -- put a string on an output file using putc()
  */
  
+ /*  -----------      deleted  by  K.Okamoto 
+ 
  puts(s, file)
  char	*s;
  FILE	*file;
***************
*** 385,387 ****
--- 387,391 ----
  	for (sp = s; *sp; )
  		putc(*sp++, f);
  }
+ 
+ ----------------------------------------------*/
diff -r -c ../ingres.ptf/source/gutil/Makefile source/gutil/Makefile
*** ../ingres.ptf/source/gutil/Makefile	Mon Nov 16 14:38:31 1992
--- source/gutil/Makefile	Thu Oct  8 13:52:52 1992
***************
*** 4,13 ****
  #	@(#)Makefile	8.3	12/18/85
  #
  
! INGRES=	../..
  H=	../h
  LIB=	$(INGRES)/lib
! CPUTYPE=VAX
  
  OBJS=	append.o atof.o bequal.o bitcnt.o bitpos.o cat.o \
  	concat.o freebuf.o ftoa.o fullwait.o \
--- 4,13 ----
  #	@(#)Makefile	8.3	12/18/85
  #
  
! INGRES=	/usr/ingres
  H=	../h
  LIB=	$(INGRES)/lib
! CPUTYPE1 = i386
  
  OBJS=	append.o atof.o bequal.o bitcnt.o bitpos.o cat.o \
  	concat.o freebuf.o ftoa.o fullwait.o \
***************
*** 16,25 ****
  	prargs.o scompare.o sequal.o set_si_buf.o set_so_buf.o \
  	setflag.o trace.o atol.o smove.o \
  	lprintf.o clrmem.o xputchar.o ztack.o syserr.o \
! 	min.o xfree.o bmove.$(CPUTYPE).o perror.o locv.o capital.o
  
  SRCS1=	append.c atof.c bequal.c bitcnt.c bitpos.c cat.c \
! 	concat.c freebuf.c ftoa.c fullwait.c \
  	getufield.c iocv.c itoa.c length.c \
  	xalloc.c need.c oatoi.c pad.c pmove.c capital.c
  SRCS2=	prargs.c scompare.c sequal.c set_si_buf.c set_so_buf.c \
--- 16,25 ----
  	prargs.o scompare.o sequal.o set_si_buf.o set_so_buf.o \
  	setflag.o trace.o atol.o smove.o \
  	lprintf.o clrmem.o xputchar.o ztack.o syserr.o \
! 	min.o xfree.o bmove.$(CPUTYPE1).o perror.o locv.o capital.o
  
  SRCS1=	append.c atof.c bequal.c bitcnt.c bitpos.c cat.c \
! 	concat.c freebuf.c fota.c fullwait.c \
  	getufield.c iocv.c itoa.c length.c \
  	xalloc.c need.c oatoi.c pad.c pmove.c capital.c
  SRCS2=	prargs.c scompare.c sequal.c set_si_buf.c set_so_buf.c \
***************
*** 26,40 ****
  	setflag.c trace.c atol.c smove.c \
  	xputchar.c ztack.c syserr.c \
  	min.c xfree.c lprintf.c clrmem.c perror.c locv.c
! ASSRC=  bmove.VAX.s bmove.SUN.c
  SRCS=	$(SRCS1) $(SRCS2) $(ASSRC)
  LINTSRCS= $(SRCS1) $(SRCS2)
  
! CFLAGS=	-I$H -O
  LINTFLAGS= -huc -I$H
  AR=	-ar
  ARFLAGS=urv
! RANLIB=	ranlib
  GET=	sccs get
  REL=
  LINT=	lint
--- 26,40 ----
  	setflag.c trace.c atol.c smove.c \
  	xputchar.c ztack.c syserr.c \
  	min.c xfree.c lprintf.c clrmem.c perror.c locv.c
! ASSRC=  bmove.VAX.s bmove.SUN.c bmove.i386.c
  SRCS=	$(SRCS1) $(SRCS2) $(ASSRC)
  LINTSRCS= $(SRCS1) $(SRCS2)
  
! CFLAGS=	-O -I$H
  LINTFLAGS= -huc -I$H
  AR=	-ar
  ARFLAGS=urv
! 
  GET=	sccs get
  REL=
  LINT=	lint
Only in source/gutil: bmove.i386.c
diff -r -c ../ingres.ptf/source/gutil/freebuf.c source/gutil/freebuf.c
*** ../ingres.ptf/source/gutil/freebuf.c	Mon Nov 16 14:38:33 1992
--- source/gutil/freebuf.c	Wed Sep 16 19:34:21 1992
***************
*** 15,25 ****
  **		seterr()
  */
  
  
  
- 
- 
- 
  /* structure that the routines use to allocate space */
  struct nodbuffer
  {
--- 15,25 ----
  **		seterr()
  */
  
+ int    freebuf();
+ int    markbuf();
+ int    seterr();
  
  
  /* structure that the routines use to allocate space */
  struct nodbuffer
  {
***************
*** 43,49 ****
  **	Side Effects:
  **		none
  */
! 
  markbuf(bf)
  struct nodbuffer	*bf;
  {
--- 43,49 ----
  **	Side Effects:
  **		none
  */
! int
  markbuf(bf)
  struct nodbuffer	*bf;
  {
***************
*** 65,71 ****
  **	Side Effects:
  **		none
  */
! 
  freebuf(bf, bytes)
  struct nodbuffer	*bf;
  int			bytes;
--- 65,71 ----
  **	Side Effects:
  **		none
  */
! int
  freebuf(bf, bytes)
  struct nodbuffer	*bf;
  int			bytes;
***************
*** 94,100 ****
  **	Side Effects:
  **		adjusts buffer structure
  */
! 
  seterr(bf, errnum, err_func)
  struct nodbuffer	*bf;
  int			errnum;
--- 94,100 ----
  **	Side Effects:
  **		adjusts buffer structure
  */
! int
  seterr(bf, errnum, err_func)
  struct nodbuffer	*bf;
  int			errnum;
diff -r -c ../ingres.ptf/source/gutil/ftoa.c source/gutil/ftoa.c
*** ../ingres.ptf/source/gutil/ftoa.c	Mon Nov 16 14:38:32 1992
--- source/gutil/ftoa.c	Thu Nov 19 14:44:27 1992
***************
*** 1,8 ****
--- 1,11 ----
+ #include <math.h>
+ #include <useful.h>
  # include	<sccs.h>
  
  SCCSID(@(#)ftoa.c	8.1	12/31/84)
  
  # define	MAXDIG		25
+ # define        MAXEXP          40
  
  /*
  **  FLOATING POINT TO ASCII CONVERSION
***************
*** 30,35 ****
--- 33,52 ----
  **	of the output field (sometimes shorter than 'width').
  */
  
+ 
+ /*
+  * Macros for converting digits to letters and vice versa
+  */
+ #define	to_digit(c)	((c) - '0')
+ #define is_digit(c)	((unsigned)to_digit(c) <= 9)
+ #define	to_char(n)	((n) + '0')
+ 
+ static char *fcvt();
+ static char *ecvt();
+ static char *round();
+ static char *exponent();
+ 
+ int
  ftoa(value, ascii, width, prec1, format)
  double	value;
  char	*ascii;
***************
*** 45,51 ****
  	char		mode;
  	int		lowercase;
  	int		prec;
! 	extern char	*ecvt(), *fcvt();
  
  	prec = prec1;
  	mode = format;
--- 62,69 ----
  	char		mode;
  	int		lowercase;
  	int		prec;
!         char            buf[MAXEXP];    /*  K.Okamoto  */
!         char      *startp, *endp;
  
  	prec = prec1;
  	mode = format;
***************
*** 58,64 ****
  	if (mode != 'E')
  	{
  		/* try 'F' style output */
! 		p = fcvt(value, prec, &expon, &sign);
  		avail = width;
  		a = ascii;
  
--- 76,85 ----
  	if (mode != 'E')
  	{
  		/* try 'F' style output */
! 	        startp = buf;
! 	        endp = buf + sizeof(buf);
! 		p = fcvt(value, prec, &expon, &sign, startp, endp);
! 
  		avail = width;
  		a = ascii;
  
***************
*** 107,113 ****
  	if (mode != 'F')
  	{
  		/* try to do E style output */
! 		p = ecvt(value, prec + 1, &expon, &sign);
  		avail = width - 5;
  		a = ascii;
  
--- 128,136 ----
  	if (mode != 'F')
  	{
  		/* try to do E style output */
! 	        startp = buf;
! 	        endp = buf + sizeof(buf);
! 		p = ecvt(value, prec + 1, &expon, &sign, startp, endp);
  		avail = width - 5;
  		a = ascii;
  
***************
*** 141,147 ****
  	avail = 1;
  
    frac_out:
! 	*a++ = '.';
  	while (prec > 0)
  	{
  		prec--;
--- 164,171 ----
  	avail = 1;
  
    frac_out:
! /*	*a++ = '.';           K.Okamoto      */
!         prec++;           /*  K.Okamoto  */
  	while (prec > 0)
  	{
  		prec--;
***************
*** 187,190 ****
--- 211,486 ----
  	*a = 0;
  	avail = a - ascii;
  	return (avail);
+ }
+ 
+ 
+ /*-
+  * Copyright (c) 1990 The Regents of the University of California.
+  * All rights reserved.
+  *
+  * This code is derived from software contributed to Berkeley by
+  * Chris Torek.
+  *
+  * Redistribution and use in source and binary forms, with or without
+  * modification, are permitted provided that the following conditions
+  * are met:
+  * 1. Redistributions of source code must retain the above copyright
+  *    notice, this list of conditions and the following disclaimer.
+  * 2. Redistributions in binary form must reproduce the above copyright
+  *    notice, this list of conditions and the following disclaimer in the
+  *    documentation and/or other materials provided with the distribution.
+  * 3. All advertising materials mentioning features or use of this software
+  *    must display the following acknowledgement:
+  *	This product includes software developed by the University of
+  *	California, Berkeley and its contributors.
+  * 4. Neither the name of the University nor the names of its contributors
+  *    may be used to endorse or promote products derived from this software
+  *    without specific prior written permission.
+  *
+  * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
+  * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+  * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+  * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
+  * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+  * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+  * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+  * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+  * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+  * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+  * SUCH DAMAGE.
+  */
+ /*  the following four functions are stolen from the source code of 
+  *  function cvt() in 386bsd itself in /usr/src/lib/libc/stdio/vfprintf.c 
+  *        by  K.Okamoto 
+  */
+ 
+ char *
+ fcvt(number, prec, expon, sign, startp, endp)
+ 	double number;
+ 	register int prec;
+ 	int *expon, *sign;
+         char *startp, *endp;
+ {
+ 	register char *p, *t;
+ 	register double fract;
+ 	int expcnt;
+ 	double integer, tmp;
+ 
+         *startp = '\0';
+ 	expcnt = 0;
+ 	if (number < 0) {
+ 		number = -number;
+ 		*sign = 1;
+ 	} else
+ 		*sign = 0;
+ 
+ 	fract = modf(number, &integer);
+ 
+ 	/* get an extra slot for rounding. */
+ 	t = ++startp;
+ 
+ 	/*
+ 	 * get integer portion of number; put into the end of the buffer; the
+ 	 * .01 is added for modf(356.0 / 10, &integer) returning .59999999...
+ 	 */
+ 	for (p = endp - 1; integer; ++expcnt) {
+ 		tmp = modf(integer / 10, &integer);
+ 		*p-- = to_char((int)((tmp + .01) * 10));
+ 	}
+ 	/* reverse integer into beginning of buffer */
+ 	if (expcnt)
+ 		for (; ++p < endp; *t++ = *p);
+ 	else
+ 		*t++ = '0';
+ 	/*
+ 	 * if precision required, add in a decimal point.
+ 	 */
+ 	if (prec )
+ 		*t++ = '.';
+ 	/* if requires more precision and some fraction left */
+ 	if (fract) {
+ 		if (prec)
+ 			do {
+ 				fract = modf(fract * 10, &tmp);
+ 				*t++ = to_char((int)tmp);
+ 			} while (--prec && fract);
+ 		if (fract)
+ 			startp = round(fract, (int *)NULL, startp,
+ 			    t - 1, (char)0, sign);
+ 	}
+ 	for (; prec--; *t++ = '0');
+         *expon = expcnt;
+ 	return ((char *)(startp));
+ }
+ 
+ 
+ char *
+ ecvt(number, prec, expon, sign, startp, endp)
+ 	double number;
+ 	register int prec;
+ 	int *expon, *sign;
+         char *startp, *endp;
+ {
+ 	register char *p, *t;
+ 	register double fract;
+ 	int expcnt, gformat;
+ 	double integer, tmp;
+ 
+         *startp = '\0';
+ 	expcnt = gformat = 0;
+ 	if (number < 0) {
+ 		number = -number;
+ 		*sign = 1;
+ 	} else
+ 		*sign = 0;
+ 
+ 	fract = modf(number, &integer);
+ 
+ 	/* get an extra slot for rounding. */
+ 	t = ++startp;
+ 
+ 	/*
+ 	 * get integer portion of number; put into the end of the buffer; the
+ 	 * .01 is added for modf(356.0 / 10, &integer) returning .59999999...
+ 	 */
+ 	for (p = endp - 1; integer; ++expcnt) {
+ 		tmp = modf(integer / 10, &integer);
+ 		*p-- = to_char((int)((tmp + .01) * 10));
+ 	}
+ 	if (expcnt) {
+ 		*t++ = *++p;
+ 		if (prec)
+ 			*t++ = '.';
+ 		/* if requires more precision and some integer left */
+ 		for (; prec && ++p < endp; --prec)
+ 			*t++ = *p;
+ 		/*
+ 		 * if done precision and more of the integer component,
+ 		 * round using it; adjust fract so we don't re-round
+ 		 * later.
+ 		 */
+ 		if (!prec && ++p < endp) {
+ 			fract = 0;
+ 			startp = round((double)0, &expcnt, startp,
+ 			    t - 1, *p, sign);
+ 		}
+ 		/* adjust expcnt for digit in front of decimal */
+ 		--expcnt;
+ 	}
+ 	/* until first fractional digit, decrement exponent */
+ 	else if (fract) {
+ 		/* adjust expcnt for digit in front of decimal */
+ 		for (expcnt = -1;; --expcnt) {
+ 			fract = modf(fract * 10, &tmp);
+ 			if (tmp)
+ 				break;
+ 		}
+ 		*t++ = to_char((int)tmp);
+ 		if (prec)
+ 			*t++ = '.';
+ 	}
+ 	else {
+ 		*t++ = '0';
+ 		if (prec)
+ 			*t++ = '.';
+ 	}
+ 	/* if requires more precision and some fraction left */
+ 	if (fract) {
+ 		if (prec)
+ 			do {
+ 				fract = modf(fract * 10, &tmp);
+ 			        *t++ = to_char((int)tmp);
+ 			} while (--prec && fract);
+ 		if (fract)
+ 			startp = round(fract, &expcnt, startp,
+ 			    t - 1, (char)0, sign);
+ 	}
+ 	/* if requires more precision */
+ 	for (; prec--; *t++ = '0');
+ 	/* unless alternate flag, trim any g/G format trailing 0's */
+ 	if (gformat) {
+ 		while (t > startp && *--t == '0');
+ 		if (*t == '.')
+ 			--t;
+ 		++t;
+ 	}
+ 	t = exponent(t, expcnt);
+         *expon = expcnt;
+ 	return ((char *)(startp));
+ }
+ 
+ static char *
+ round(fract, exp, start, end, ch, sign)
+ 	double fract;
+ 	int *exp;
+ 	register char *start, *end;
+ 	char ch;
+         int *sign;
+ {
+ 	double tmp;
+ 
+ 	if (fract)
+ 		(void)modf(fract * 10, &tmp);
+ 	else
+ 		tmp = to_digit(ch);
+ 	if (tmp > 4)
+ 		for (;; --end) {
+ 			if (*end == '.')
+ 				--end;
+ 			if (++*end <= '9')
+ 				break;
+ 			*end = '0';
+ 			if (end == start) {
+ 				if (exp) {	/* e/E; increment exponent */
+ 					*end = '1';
+ 					++*exp;
+ 				}
+ 				else {		/* f; add extra digit */
+ 				*--end = '1';
+ 				--start;
+ 				}
+ 				break;
+ 			}
+ 		}
+ 	/* ``"%.3f", (double)-0.0004'' gives you a negative 0. */
+ 	else if (*sign != 0)
+ 		for (;; --end) {
+ 			if (*end == '.')
+ 				--end;
+ 			if (*end != '0')
+ 				break;
+ 			if (end == start)
+ 				*sign = 0;
+ 		}
+ 	return (start);
+ }
+ 
+ static char *
+ exponent(p, exp)
+ 	register char *p;
+ 	register int exp;
+ {
+ 	register char *t;
+ 	char expbuf[MAXEXP];
+ 
+ 	*p++ = 'E';
+ 	if (exp < 0) {
+ 		exp = -exp;
+ 		*p++ = '-';
+ 	}
+ 	else
+ 		*p++ = '+';
+ 	t = expbuf + MAXEXP;
+ 	if (exp > 9) {
+ 		do {
+ 			*--t = to_char(exp % 10);
+ 		} while ((exp /= 10) > 9);
+ 		*--t = to_char(exp);
+ 		for (; t < expbuf + MAXEXP; *p++ = *t++);
+ 	}
+ 	else {
+ 		*p++ = '0';
+ 		*p++ = to_char(exp);
+ 	}
+ 	return (p);
  }
diff -r -c ../ingres.ptf/source/gutil/syserr.c source/gutil/syserr.c
*** ../ingres.ptf/source/gutil/syserr.c	Mon Nov 16 14:38:35 1992
--- source/gutil/syserr.c	Tue Jun  9 13:09:44 1992
***************
*** 22,29 ****
  
  char	*Proc_name;
  int	Accerror;
! extern	exit(), abort();
! int	(*ExitFn)()	 = exit;
  
  syserr(pv)
  char	*pv;
--- 22,29 ----
  
  char	*Proc_name;
  int	Accerror;
! extern	void exit(), abort();
! void	(*ExitFn)()	 = exit;
  
  syserr(pv)
  char	*pv;
diff -r -c ../ingres.ptf/source/h/func.h source/h/func.h
*** ../ingres.ptf/source/h/func.h	Mon Nov 16 14:38:26 1992
--- source/h/func.h	Mon Sep 14 18:42:08 1992
***************
*** 11,18 ****
  {
  	char		*fn_name;	/* the name of the function */
  	int		(*fn_fn)();	/* a pointer to the actual function */
! 	int		(*fn_initfn)();	/* initialization function */
! 	int		(*fn_cleanup)();/* interrupt cleanup function */
  	char		*fn_gptr;	/* pointer to global space */
  	unsigned	fn_gsize;	/* size of global space */
  	short		*fn_tvect;	/* the trace vector itself */
--- 11,20 ----
  {
  	char		*fn_name;	/* the name of the function */
  	int		(*fn_fn)();	/* a pointer to the actual function */
! /*	int		(*fn_initfn)();	 initialization function */
! /*	int		(*fn_cleanup)(); interrupt cleanup function */
! 	void		(*fn_initfn)();	/* initialization function */
! 	void		(*fn_cleanup)();/* interrupt cleanup function */
  	char		*fn_gptr;	/* pointer to global space */
  	unsigned	fn_gsize;	/* size of global space */
  	short		*fn_tvect;	/* the trace vector itself */
diff -r -c ../ingres.ptf/source/h/ingres.h source/h/ingres.h
*** ../ingres.ptf/source/h/ingres.h	Mon Nov 16 14:38:25 1992
--- source/h/ingres.h	Fri Sep 25 14:20:56 1992
***************
*** 1,4 ****
- 
  /*
  **  INGRES.H -- basic header file for ingres.
  **
--- 1,3 ----
***************
*** 25,31 ****
  **	Currently the default is to the 32 bits existant on VAX 11/780s.
  */
  
! # ifndef	sun
  # define	VAX
  # endif
  
--- 24,31 ----
  **	Currently the default is to the 32 bits existant on VAX 11/780s.
  */
  
! # ifdef i386                   /*  by   K.Okamoto   */
! /*   # ifndef sun                  by   K.Okamoto   */
  # define	VAX
  # endif
  
***************
*** 131,140 ****
  
  struct tup_id
  {
! # ifdef VAX
  	c_1	line_id, pg2, pg1, pg0;
  # else
  	c_1	pg0, pg1, pg2, line_id;
  # endif
  };
  
--- 131,142 ----
  
  struct tup_id
  {
! # ifdef VAX   /*  also for i386   by  K.Okamoto */
  	c_1	line_id, pg2, pg1, pg0;
+ /*	c_1	pg2, pg1, pg0, line_id;    K.Okamoto  */
  # else
  	c_1	pg0, pg1, pg2, line_id;
+ /*	c_1	line_id, pg0, pg1, pg2;    K.Okamoto  */
  # endif
  };
  
diff -r -c ../ingres.ptf/source/h/lock.h source/h/lock.h
*** ../ingres.ptf/source/h/lock.h	Mon Nov 16 14:38:26 1992
--- source/h/lock.h	Mon Jun  8 12:50:52 1992
***************
*** 34,40 ****
  					 *	=1 request lock,err return
  					 *	=2 request lock,sleep
  					 *	=3 release lock
! 					 *	=release all locks for pid
  					 */
  	char	lrtype;			/* type of lock:
  					 *   =0, critical section lock
--- 34,40 ----
  					 *	=1 request lock,err return
  					 *	=2 request lock,sleep
  					 *	=3 release lock
! 					 *	=4 release all locks for pid
  					 */
  	char	lrtype;			/* type of lock:
  					 *   =0, critical section lock
diff -r -c ../ingres.ptf/source/h/opsys.h source/h/opsys.h
*** ../ingres.ptf/source/h/opsys.h	Mon Nov 16 14:38:26 1992
--- source/h/opsys.h	Mon Oct  5 14:31:43 1992
***************
*** 1,5 ****
- #
- 
  /*
  **  OPSYS.H -- operating system dependent definitions.
  **
--- 1,3 ----
diff -r -c ../ingres.ptf/source/h/resp.h source/h/resp.h
*** ../ingres.ptf/source/h/resp.h	Mon Nov 16 14:38:27 1992
--- source/h/resp.h	Thu Jun  4 15:42:33 1992
***************
*** 13,19 ****
  	long	resp_tups;	/* count of tuples touched */
  	long	resp_pread;	/* pages read */
  	long	resp_pwrit;	/* pages written */
! 	/* PARM	resp_rval;	/* the module return value */
  };
  
  extern struct resp	Resp;	/* the current response */
--- 13,19 ----
  	long	resp_tups;	/* count of tuples touched */
  	long	resp_pread;	/* pages read */
  	long	resp_pwrit;	/* pages written */
! 	/* PARM	resp_rval;	 the module return value */
  };
  
  extern struct resp	Resp;	/* the current response */
diff -r -c ../ingres.ptf/source/iutil/Makefile source/iutil/Makefile
*** ../ingres.ptf/source/iutil/Makefile	Mon Nov 16 14:38:41 1992
--- source/iutil/Makefile	Fri Sep 25 17:53:34 1992
***************
*** 43,49 ****
  	sort.c
  SRCS=	$(SRCS1) $(SRCS2) 
  
! CFLAGS=	-I$H -O -I../ctlmod
  LINTFLAGS = -huc -I$H
  AR=	-ar
  ARFLAGS=urv
--- 43,49 ----
  	sort.c
  SRCS=	$(SRCS1) $(SRCS2) 
  
! CFLAGS=	-O -I$H -I../ctlmod
  LINTFLAGS = -huc -I$H
  AR=	-ar
  ARFLAGS=urv
diff -r -c ../ingres.ptf/source/iutil/accbuf.c source/iutil/accbuf.c
*** ../ingres.ptf/source/iutil/accbuf.c	Mon Nov 16 14:38:41 1992
--- source/iutil/accbuf.c	Mon Oct 19 18:52:44 1992
***************
*** 31,37 ****
  int		Acc_init	=	FALSE;
  
  char		Acclock;		/* locks enabled flag */
! int		Alockdes;		/* file descriptor for lock device*/
  int		Lockrel;		/* lock relations flag*/
  /*
  **	Flush the indicated page and reset all
--- 31,37 ----
  int		Acc_init	=	FALSE;
  
  char		Acclock;		/* locks enabled flag */
! extern int	Alockdes;		/* file descriptor for lock device*/
  int		Lockrel;		/* lock relations flag*/
  /*
  **	Flush the indicated page and reset all
diff -r -c ../ingres.ptf/source/iutil/dblocks.c source/iutil/dblocks.c
*** ../ingres.ptf/source/iutil/dblocks.c	Mon Nov 16 14:38:41 1992
--- source/iutil/dblocks.c	Mon Oct 19 18:56:21 1992
***************
*** 5,10 ****
--- 5,11 ----
  SCCSID(@(#)dblocks.c	8.2	6/12/88)
  
  struct	lockreq	Lock;
+ 
  /*
   *	setdbl - set data base lock for either exclusive or shared
   *		 access.
***************
*** 18,24 ****
  	auto	int	ret_val;
  
  #	ifdef xATR1
! 	if ( tTf(28,6) )
  		printf(" setdbl act=%o md=%o\n", act, mod);
  #	endif
  	if (Alockdes < 0)
--- 19,25 ----
  	auto	int	ret_val;
  
  #	ifdef xATR1
! 	if ( tTf(28,6) ) 
  		printf(" setdbl act=%o md=%o\n", act, mod);
  #	endif
  	if (Alockdes < 0)
diff -r -c ../ingres.ptf/source/iutil/getservent.c source/iutil/getservent.c
*** ../ingres.ptf/source/iutil/getservent.c	Mon Nov 16 14:38:45 1992
--- source/iutil/getservent.c	Wed Sep 16 12:44:12 1992
***************
*** 5,16 ****
  #include <sys/socket.h>
  #include <netdb.h>
  #include <ctype.h>
! # include	<sccs.h>
  
  SCCSID(@(#)getservent.c	8.1	12/31/84)
  
  #define	MAXALIASES	35
  
  static char SERVDB[] = "/etc/services";
  static FILE *servf = NULL;
  static char line[BUFSIZ+1];
--- 5,22 ----
  #include <sys/socket.h>
  #include <netdb.h>
  #include <ctype.h>
! #include <sccs.h>
  
  SCCSID(@(#)getservent.c	8.1	12/31/84)
  
  #define	MAXALIASES	35
  
+ void        setservent();
+ void        endservent();
+ struct servent *getservent();
+ static char *any();
+ static int  myatoi();
+ 
  static char SERVDB[] = "/etc/services";
  static FILE *servf = NULL;
  static char line[BUFSIZ+1];
***************
*** 17,24 ****
  static struct servent serv;
  static char *serv_aliases[MAXALIASES];
  static int stayopen = 0;
- static char *any();
  
  setservent(f)
  	int f;
  {
--- 23,30 ----
  static struct servent serv;
  static char *serv_aliases[MAXALIASES];
  static int stayopen = 0;
  
+ void                        /* added by K.Okamoto  */ 
  setservent(f)
  	int f;
  {
***************
*** 29,34 ****
--- 35,41 ----
  	stayopen |= f;
  }
  
+ void                      /* added by K.Okamoto  */
  endservent()
  {
  	if (servf && !stayopen) {
diff -r -c ../ingres.ptf/source/iutil/ingresname.c source/iutil/ingresname.c
*** ../ingres.ptf/source/iutil/ingresname.c	Mon Nov 16 14:38:45 1992
--- source/iutil/ingresname.c	Tue Sep 22 14:36:47 1992
***************
*** 3,8 ****
--- 3,11 ----
  
  SCCSID(@(#)ingresname.c	8.1	12/31/84)
  
+ extern char	*pmove();
+ int  ingresname();
+ 
  /*
  **  MAKE INGRES FILE NAME
  **
***************
*** 21,27 ****
  char	*outname;
  {
  	register char	*p;
- 	extern char	*pmove();
  
  	p = outname;
  	p = pmove(iname, p, MAXNAME, ' ');
--- 24,29 ----
diff -r -c ../ingres.ptf/source/iutil/initucode.c source/iutil/initucode.c
*** ../ingres.ptf/source/iutil/initucode.c	Mon Nov 16 14:38:41 1992
--- source/iutil/initucode.c	Mon Oct 19 18:23:41 1992
***************
*** 145,151 ****
  char	*Pathname;	/* path of INGRES subtree */
  int	Status;		/* the user status of the real user */
  int	Rubignored;	/* set if rubouts ignored */
! 			/* (also in initproc for system processes) */
  int	Wait_action;	/* the action on the db_lock */
  char	*Dbpath;	/* the pathname of the database */
  char	*Flagvect[MAXFARGS+1];	/* the flags from argv */
--- 145,151 ----
  char	*Pathname;	/* path of INGRES subtree */
  int	Status;		/* the user status of the real user */
  int	Rubignored;	/* set if rubouts ignored */
! 		/* (also in initproc for system processes) */
  int	Wait_action;	/* the action on the db_lock */
  char	*Dbpath;	/* the pathname of the database */
  char	*Flagvect[MAXFARGS+1];	/* the flags from argv */
***************
*** 153,158 ****
--- 153,179 ----
  int	Ing_uid;	/* the user id of the INGRES user */
  jmp_buf	Initbuf;	/* Buffer to go back to initucode with */
  
+ #ifndef gtty
+ #define gtty(fd, argp) ioctl(fd, TIOCGETP, argp)
+ #endif
+ #ifndef stty
+ #define stty(fd, argp) ioctl(fd, TIOCSETP, argp)
+ #endif
+ 
+ int    initucode();
+ int    db_lock();
+ int    initdbpath();
+ extern	void	rubcatch();
+ 
+ /*------ needless for 386bsd  by  K.Okamoto -------
+ 	struct	passwd	*getpwnam();
+ # ifdef xV7_UNIX
+ 	extern char	*getenv();
+ # endif xV7_UNIX
+ -------------------------------------------------*/
+ 
+ 
+ int
  initucode(argc, argv, dbflag, paramlist, waitmode)
  int	argc;
  char	**argv;
***************
*** 180,193 ****
  	int		fvi, pvi;
  	char		**avp;
  	char		usr_ovrd[3];
- 	extern		rubcatch();
  	static short	tvect[100];
  	bool		nobuffer;
  	struct	passwd	*pwd;
- 	struct	passwd	*getpwnam();
- # ifdef xV7_UNIX
- 	extern char	*getenv();
- # endif xV7_UNIX
  
  	/*
  	**  Set up interrupts.
--- 201,209 ----
***************
*** 223,229 ****
  	if ( (pwd = getpwnam(USERINGRES)) == NULL )
  		syserr("initucode: No user %s in password file",USERINGRES);
  # ifdef xV7_UNIX
! 	Pathname = getenv("INGPATH");
  	if (Pathname == NULL)
  	{
  # endif xV7_UNIX
--- 239,245 ----
  	if ( (pwd = getpwnam(USERINGRES)) == NULL )
  		syserr("initucode: No user %s in password file",USERINGRES);
  # ifdef xV7_UNIX
! 	Pathname = (char *)getenv("INGPATH");
  	if (Pathname == NULL)
  	{
  # endif xV7_UNIX
***************
*** 329,335 ****
  	**  Scan the "users" file.
  	*/
  
! 	if ((iop = fopen(ztack(Pathname, "/files/users"), "r")) == NULL)
  		syserr("initucode: open error");
  	
  	/* get uid (out of loop) for test */
--- 345,351 ----
  	**  Scan the "users" file.
  	*/
  
! 	if ((iop = fopen((char *)ztack(Pathname, "/files/users"), "r")) == NULL)
  		syserr("initucode: open error");
  	
  	/* get uid (out of loop) for test */
***************
*** 407,413 ****
  		*/
  
  		Usercode = sbufp;
! 		sbufp += smove(field[UF_UCODE], sbufp) + 1;
  		Status = oatoi(field[UF_STAT]);
  		if (paramlist != NULL)
  		{
--- 423,430 ----
  		*/
  
  		Usercode = sbufp;
!                 sbufp += smove(field[UF_UCODE], sbufp) + 1;
! 
  		Status = oatoi(field[UF_STAT]);
  		if (paramlist != NULL)
  		{
***************
*** 490,496 ****
  
  		if (rtval == 0 || rtval == INDIRECT)
  		{
! 			i = open(ztack(Dbpath, "/admin"), O_RDONLY);
  			if (i < 0)
  				rtval += 1;
  			else
--- 507,513 ----
  
  		if (rtval == 0 || rtval == INDIRECT)
  		{
! 			i = open((char *)ztack(Dbpath, "/admin"), O_RDONLY);
  			if (i < 0)
  				rtval += 1;
  			else
***************
*** 566,571 ****
--- 583,589 ----
  
  struct lockreq	Lock;	/* the database lock structure */
  
+ int
  db_lock(mode)
  int	mode;
  {
***************
*** 579,584 ****
--- 597,603 ----
  		exit(1);
  	}
  }
+ 
  /*
  **  INITDBPATH -- initialize the pathname of the database
  **
***************
*** 605,610 ****
--- 624,630 ----
  **		none.
  */
  
+ int
  initdbpath(database, dbpath, follow)
  char	*database;
  char	*dbpath;
